/* --------------------------------------------------------
   qɔԂvOizŁj

   ̃\[XR[h́CM҂̂쐬̂
   ҏWŎ̂łB

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


/* -------------------------------------------------------- */
#define true            (1)
#define false           (0)

/* }bv̓e */
#define ITEM_WALL       ('*')
#define ITEM_PATH       ('.')
#define ITEM_GOAL       ('%')
#define ITEM_BOX        ('o')
#define ITEM_PLAYER     ('@')
#define ITEM_GOAL_BOX   ('G')

/* }bv̑傫 */
#define MAP_WIDTH       (9)
#define MAP_HEIGHT      (8)

/* ̐ */
#define MAP_BOXLIMIT    (3)

/* ړ */
#define STEP_LEFT   0
#define STEP_RIGHT  1
#define STEP_UP     2
#define STEP_DOWN   3


/* -------------------------------------------------------- */
/* Ֆʃf[^ */
unsigned char map[MAP_WIDTH][MAP_HEIGHT];

/* Ֆʂ̌f[^ */
unsigned char *mapstr = {
    "*********"
    "*.......*"
    "*.**o**.*"
    "*.@...o.*"
    "**o%%%*.*"
    "**....*.*"
    "****..***"
    "*********"
};


/* -------------------------------------------------------- */
/* x, y 2_Ԃ\ */
typedef struct {
    int x, y;
} t_point;

/* TpL[Ɏg1vf̃m[h */
typedef struct node {
    t_point boxpos[MAP_BOXLIMIT]; /* ̈ʒu                       */
    t_point playerpos;            /* vC[ʒu           */
    struct node *backnode;        /* vC[Oɂm[h     */
    int cost;                     /* ݈ʒũRXg(Ⴂقǂ悢) */
} t_node;

t_point goalpos[MAP_BOXLIMIT];  /* S[̈ʒu */
t_node *endnode;                /* S[ɒBm[h */

/* 4𒲂ׂ邽߂̑΍W */
/* ", "", "E", ""̏ */
t_point areadifpos[] = {{-1,  0}, {0, -1},  
                        {1, 0},   {0, 1}};


/* -------------------------------------------------------- */
/* ς݂̃m[h{̂i[obt@ */
#define NODEBUF_LIMIT (0x10000)
t_node nodebuf[NODEBUF_LIMIT];
int nodebuf_head = 0;

/* VKm[hp̃[蓖ĂẴAhXԂ */
t_node *get_newnode(void)
{
    if (nodebuf_head >= NODEBUF_LIMIT) {
        fprintf(stderr, "nodebuf overflow\n");
        exit(-1);
    }
    return &nodebuf[nodebuf_head++];
}

/* w肵Ԃς݂ǂ𔻒肷 */
/* `TȂ̂Œx                       */
int isalreadyvisited(t_node *node)
{
    int i, j;

    for(i = nodebuf_head; i >= 0; i--) {
        if(node->playerpos.x != nodebuf[i].playerpos.x ||
            node->playerpos.y != nodebuf[i].playerpos.y)    
            continue;
        for(j = 0; j < MAP_BOXLIMIT; j++){
            if(node->boxpos[j].x != nodebuf[i].boxpos[j].x ||
                node->boxpos[j].y!= nodebuf[i].boxpos[j].y) 
                break;
        }
        if(j >= MAP_BOXLIMIT) return true;

    }
    return false;
}


/* -------------------------------------------------------- */
/* TpL[ */
#define SEARCHQUE_LIMIT  (256 * 10)
t_node *searchque[SEARCHQUE_LIMIT];
int searchque_head = 0;

/* Vm[hTpL[ɃZbg */
void que_push(t_node *node)
{
    t_node *tmpnode;
    int i;

    if (searchque_head >= SEARCHQUE_LIMIT) {
        fprintf(stderr, "searchque overflow\n");
        exit(-1);
    }

    i = searchque_head - 1;
    while(i >= 0 && node->cost > searchque[i]->cost) {
        searchque[i + 1] = searchque[i];
        i--;
    }

    searchque[i + 1] = node;
    searchque_head++;
}

/* L[To  */
t_node *que_pop(void)
{
    if (searchque_head == 0){
        fprintf(stderr, "searchque underflow\n");
        exit(-1);
    }
    searchque_head--;
    return searchque[searchque_head];
}


/* -------------------------------------------------------- */
/* f[^֘A */

/* ŏ̃m[h */
t_node *playstep_makerootnode(void)
{
    int x, y, boxcount, goalcount;
    t_node *node;

    node = get_newnode();
    node->backnode = NULL;
    node->cost = 1000000;

    /* }bvT
       S[//vC[̈ʒu𓾂 */
    boxcount = 0;
    goalcount = 0;
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            switch (map[x][y]) {
            case ITEM_GOAL:
                goalpos[goalcount].x = x;
                goalpos[goalcount].y = y;
                goalcount++;
                break;
            case ITEM_BOX:
                node->boxpos[boxcount].x = x;
                node->boxpos[boxcount].y = y;
                boxcount++;
                map[x][y] = ITEM_PATH;
                break;
            case ITEM_PLAYER:
                node->playerpos.x = x;
                node->playerpos.y = y;
                map[x][y] = ITEM_PATH;
                break;
            }
        }
    }
    
    return node;
}

/* }bv̏s */
void mapinit(void)
{
    int x, y, i;

    i = 0;
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            map[x][y] = mapstr[i];
            i++;
        }
    }
}


/* -------------------------------------------------------- */
/* S[̏dȂ𒲂ׂ */

/* ͈&ǃ`FbN */
int playstep_movecheck(t_point *checkpos)
{
    /* ͈̓`FbN */
    if ((checkpos->x < 0) || (checkpos->x >= MAP_WIDTH) ||  
        (checkpos->y < 0) || (checkpos->y >= MAP_HEIGHT))
        return false;
    
    /* ǂǂmF */
    if (map[checkpos->x][checkpos->y] == ITEM_WALL)
        return false;

    return true;
}

/* w肳ꂽ|CgƉו̈ʒudȂ邩ǂ𓾂 */
int playstep_boxcheck(t_node *node, t_point *pos)
{
    int i;

    for (i = 0; i < MAP_BOXLIMIT; i++) {
        if ((node->boxpos[i].x == pos->x) &&
            (node->boxpos[i].y == pos->y)) {
            return i;
        }
    }
    return -1;
}

/* w肵1S[ɂ邩ׂ */
int playstep_boxtogoal_check(t_point *boxpos)
{
    int i;

    for (i = 0; i < MAP_BOXLIMIT; i++) {
        if ((boxpos->x == goalpos[i].x) &&
            (boxpos->y == goalpos[i].y)) {
            return true;
        }
    }
    return false;
}

/* ̃S[ɔ邩ׂ */
int playstep_goaltobox_check(t_node *node, t_point *checkgoalpos)
{
    int i;

    for (i = 0; i < MAP_BOXLIMIT; i++) {
        if ((node->boxpos[i].x == checkgoalpos->x) &&
            (node->boxpos[i].y == checkgoalpos->y)) {
            return true;
        }
    }
    return false;
}

/* ׂĂ̔S[ɂ邩ǂԂ */
int playstep_goalcheck(t_node *node)
{
    int i;

    for (i = 0; i < MAP_BOXLIMIT; i++) {
        if (!playstep_boxtogoal_check(&node->boxpos[i]))
            return false;
    }
    return true;
}

/* ɒl𑫂 */
int playstep_dirinc(int dir, int add)
{
    return (dir + add + 4) % 4;
}

/* ړł邩ׂ */
int playstep_boxmovecheck(t_node *node, t_point *newplayerpos, int dir)
{
    int boxindex, overboxindex, overdir, i;
    t_point newboxpos, overboxpos, nextoverboxpos;

    /* Y锠T */
    boxindex = playstep_boxcheck(node, newplayerpos);
    if (boxindex < 0)
        return -1;

    newboxpos.x = node->boxpos[boxindex].x + areadifpos[dir].x;
    newboxpos.y = node->boxpos[boxindex].y + areadifpos[dir].y;
    
    /* Vʒuɂ锠Ȃ̂Ȃ-1Ԃ */
    if (!playstep_movecheck(&newboxpos))
        return -1;

    /* ̐ɔ邩ǂׂ */
    overboxindex = playstep_boxcheck(node, &newboxpos);
    if (overboxindex >= 0)
        return -1;

    return boxindex;
}


/* -------------------------------------------------------- */
/* ]֘A */

/* roHɏQ邩ׂ */
int isclearpath(t_node *node, t_point *pos1, t_point *pos2)
{
    t_point checkpos;
    int dx, dy, x, y, count, boxindex;

    dx = abs(pos1->x - pos2->x);
    dy = abs(pos1->y - pos2->y);
    checkpos.y = min(pos1->y, pos2->y);

    count = 0;
    for (y = 0; y <= dy; y++, checkpos.y++) {
        checkpos.x = min(pos1->x, pos2->x);
        for (x = 0; x <= dx; x++, checkpos.x++) {
            if (((pos1->x == checkpos.x) && (pos1->y == checkpos.y)) || 
                ((pos2->x == checkpos.x) && (pos2->y == checkpos.y)))
                continue;
            if (!playstep_movecheck(&checkpos) ||
                (playstep_boxcheck(node, &checkpos) != -1)) {
                count++;
            }
        }
    }
    return count;
}

/* 2_Ԃ̋𑪂 */
int distance(t_point *pos1, t_point *pos2)
{
    int dx, dy, d;

    dx = abs(pos1->x - pos2->x);
    dy = abs(pos1->y - pos2->y);
    dx *= 100;
    dy *= 100;
    d = ((dx < dy) ? dx : dy) / 2;
    return (dx + dy) - d;
}

/* ו1S[1ɋ߂Âǂ𒲂ׂ */
int playstep_getboxtogoalcost(t_node *node, t_point *boxpos, t_point *goalpos)
{
    int boxcost, nomovecount;

    if ((boxpos->x == goalpos->x) &&    
        (boxpos->y == goalpos->y))
        return 0;
    if (playstep_goaltobox_check(node, goalpos))
        return 0;

    boxcost = distance(boxpos, goalpos);
    nomovecount = isclearpath(node, boxpos, goalpos);

    /* rɏQ悤ȂRXgQ̐Ԃ{ɂ */
    if (nomovecount > 0)
        boxcost *= nomovecount + 1;

    return boxcost;
}

/* ו1S[ׂĂɂǂꂾ߂Âׂ */
int playstep_getallgoalcost(t_node *node, t_point *boxpos)
{
    int boxcost, totalboxcost, goalindex;

    totalboxcost = 0;
    for (goalindex = 0; goalindex < MAP_BOXLIMIT; goalindex++) {
        if ((boxpos->x == goalpos[goalindex].x) &&  
            (boxpos->y == goalpos[goalindex].y)) {
            return 0;
        }
        boxcost = playstep_getboxtogoalcost(node, boxpos, &goalpos[goalindex]);
        totalboxcost += boxcost;
    }
    return totalboxcost;
}

/* ]p̊֐ */
/* /lS[ɂǂꂾ߂Âv */
int playstep_getcost(t_node *node)
{
    int areacosttable[8] = {0, 50, 100, 150, 200, 140,  90, 40};
    t_point areadifpostable[4][8] = {
        {{0,  0}, {0, -1},  {1,  -1},  {2,  -1}, {2,   0}, {2,   1}, {1,   1},  {0, 1}},
        {{0,  0}, {1,  0},  {1,   1},  {1,   2}, {0,   2}, {-1,  2}, {-1,  1},  {-1, 0}},
        {{0,  0}, {0, -1},  {-1, -1},  {-2, -1}, {-2,  0}, {-2,  1}, {-1,  1}, {0, 1}},
        {{0,  0}, {1,  0},  {1,  -1},  {1,  -2}, {0,  -2}, {-1, -2}, {-1, -1}, {-1, 0}},
    };

    int i, cost, playercost, boxcost[MAP_BOXLIMIT], boxindex,   
        targetbox, targetboxcost, targetgoalindex, goalindex,
        areatopcost, areacost, areapos, areaindex;
    t_point newplayerpos, pos;

    cost = 0;

    /* ܂וS[܂ł̃RXgT */
    targetboxcost = 100000;
    targetbox = 0;
    for (boxindex = 0; boxindex < MAP_BOXLIMIT; boxindex++) {
        boxcost[boxindex] = playstep_getallgoalcost(node, &node->boxpos[boxindex]);
        boxcost[boxindex] *= 2;  /* ̃RXgƑ邽2{ɂĂ */

        /* S[Ɉԋ߂וi^[Qbgj߂ */
        /* S[Ă̂̓JEgȂ */
        if ((boxcost[boxindex] != 0) && (targetboxcost > boxcost[boxindex])) {
            targetboxcost = boxcost[boxindex];
            targetbox = boxindex;
        }
        cost += boxcost[boxindex];
    }
    
    /* ^[Qbgɋ߂S[T */
    targetgoalindex = 0;
    areatopcost = 100000;
    for (goalindex = 0; goalindex < MAP_BOXLIMIT; goalindex++) {
        /* łɉוS[͎gȂ */
        if (playstep_goaltobox_check(node, &goalpos[goalindex]))
            continue;
        areacost = distance(&node->boxpos[targetbox], &goalpos[goalindex]);
        if (areacost < areatopcost) {
            areatopcost = areacost;
            targetgoalindex = goalindex;
        }
    }
    
    /* וʒûȂŁCԃS[牓ƂT */
    areatopcost = 0;
    areaindex = 0;
    for (i = 0; i < 4; i++) {
        pos.x = node->boxpos[targetbox].x + areadifpos[i].x;
        pos.y = node->boxpos[targetbox].y + areadifpos[i].y;
        areacost = distance(&pos, &goalpos[targetgoalindex]);
        /* ȂȂRXg0ɂ=̗pȂ悤ɂ */
        if (playstep_boxmovecheck(node, &node->boxpos[targetbox], playstep_dirinc(i, 2)) < 0)
            areacost = 0;

        if (areacost >= areatopcost) {
            areatopcost = areacost;
            areaindex = i;
        }
    }

    /* ʒu܂ł̃RXg𓾂 */
    areacost = -1;
    for (i = 0; i < 8; i++) {
        pos.x = node->boxpos[targetbox].x + areadifpos[areaindex].x;
        pos.y = node->boxpos[targetbox].y + areadifpos[areaindex].y;
        pos.x += areadifpostable[areaindex][i].x;
        pos.y += areadifpostable[areaindex][i].y;
        if ((node->playerpos.x == pos.x) && (node->playerpos.y == pos.y)) {
            areacost = areacosttable[i];
            break;
        }
    }

    /* ̎ӂɂȂCʒu܂ł̋RXgɂ */
    if (areacost == -1) {
        pos.x = node->boxpos[targetbox].x + areadifpos[areaindex].x;
        pos.y = node->boxpos[targetbox].y + areadifpos[areaindex].y;
        playercost = distance(&node->playerpos, &pos);
        areacost = playercost + 300;
    }
    cost += areacost;

    /* ^[QbgȊỎוRXgƂĒǉ */
    for (boxindex = 0; boxindex < MAP_BOXLIMIT; boxindex++) {
        if (targetbox != boxindex)
            cost += boxcost[boxindex];
    }
    return cost;
}


/* -------------------------------------------------------- */
/* ̕ւ̈ړ𒲂ׂ/ݒ肷 */

/* ړł邩ǂԂ */
int playstep_playermovecheck(t_node *node, int dir)
{
    int boxindex;
    t_point checkpos;

    checkpos.x = node->playerpos.x + areadifpos[dir].x;
    checkpos.y = node->playerpos.y + areadifpos[dir].y;

    /* ͈&ǃ`FbN */
    if (!playstep_movecheck(&checkpos))
        return false;

    /* ړɔƂC֓̕邩ǂ */
    boxindex = playstep_boxcheck(node, &checkpos);
    if (boxindex >= 0) {
        if (playstep_boxmovecheck(node, &checkpos, dir) < 0)
            return false;
    }
    return true;
}

/* ̕ֈړ */
void playstep_playermove(t_node *newnode, t_node *node, t_point *difpos)
{
    int i, boxpos;

    /* vC[ړ */
    newnode->playerpos.x = node->playerpos.x + difpos->x;
    newnode->playerpos.y = node->playerpos.y + difpos->y;

    /* ̈ʒuVm[hɃRs[ */
    for (i = 0; i < MAP_BOXLIMIT; i++) {
        newnode->boxpos[i].x = node->boxpos[i].x;
        newnode->boxpos[i].y = node->boxpos[i].y;
        /* ̕ɔ΁CĂ     */
        /* OiKŃ`FbNĂ̂             */
        /* ł̓`FbNɂ̂܂܉Ă */
        if ((newnode->boxpos[i].x == newnode->playerpos.x) &&
            (newnode->boxpos[i].y == newnode->playerpos.y)) {
            newnode->boxpos[i].x = node->boxpos[i].x + difpos->x;
            newnode->boxpos[i].y = node->boxpos[i].y + difpos->y;
        }
    }
}


/* -------------------------------------------------------- */
/* }bv\ */
void printmap(t_node *node)
{
    unsigned char tmpmap[MAP_WIDTH][MAP_HEIGHT];
    int x, y, i;
    
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            switch (map[x][y]) {
              case ITEM_GOAL:
              case ITEM_BOX:
              case ITEM_PLAYER:
                tmpmap[x][y] = ITEM_PATH;
                break;
              default:
                tmpmap[x][y] = map[x][y];
                break;
            }
        }
    }

    for (i = 0; i < MAP_BOXLIMIT; i++) {
        x = node->boxpos[i].x;
        y = node->boxpos[i].y;
        tmpmap[x][y] = ITEM_BOX;
    }
    for (i = 0; i < MAP_BOXLIMIT; i++) {
        x = goalpos[i].x;
        y = goalpos[i].y;
        if (tmpmap[x][y] == ITEM_BOX) {
            tmpmap[x][y] = ITEM_GOAL_BOX;
        } else {
            tmpmap[x][y] = ITEM_GOAL;
        }
    }

    x = node->playerpos.x;
    y = node->playerpos.y;
    tmpmap[x][y] = ITEM_PLAYER;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            printf("%c", tmpmap[x][y]);
        }
        printf("\n");
    }
    printf("\n");
}

#define DIRBUF_LIMIT (1024)

/* Xebv\ */
void printstep(void)
{
    static char *dirmsg[] = {"", "", "E", ""};
    t_node *node;
    int dirbuf[DIRBUF_LIMIT];
    int i, dir, step, difx, dify;

    dirbuf[0] = 0;
    node = endnode;
    step = 0;

    while (node->backnode != NULL) {
        difx = node->playerpos.x - node->backnode->playerpos.x;
        dify = node->playerpos.y - node->backnode->playerpos.y;
        if(difx != 0) dirbuf[step] = difx + 1;
        else          dirbuf[step] = dify + 2;
        step++;
        node = node->backnode;
    }

    printf("X^[g\n---\n");
    for (i = 1; i <= step; i++) {
        dir = dirbuf[step - i];
        printf("%s", dirmsg[dir]);
        if ((i % 16) == 0)  
            printf("\n");
    }
    printf("\n---\nv%d\nI\n", step);
}


/* -------------------------------------------------------- */
/* ̎T */
void playstep_search(void)
{
    t_node *nownode, *newnode, tmpnode;
    int i;

    /* ŏ̃m[h */
    nownode = playstep_makerootnode();
    que_push(nownode);

    /* וS[ɂǂ蒅܂Ń[v */
    while (!playstep_goalcheck(nownode)) {
        /* m[ho */
        nownode = que_pop();

        /* 4ׂ */
        for (i = 0; i < 4; i++) {
            /* ړł邩ǂmF */
            if (!playstep_playermovecheck(nownode, i)) continue;

            /* Vm[h̐lו̈ʒu߂ */
            playstep_playermove(&tmpnode, nownode, &areadifpos[i]);

            /* łɒς݂Ȃo^Ȃ */
            if(isalreadyvisited(&tmpnode)) continue;

            /* Vm[hzɓo^ */
            newnode = get_newnode();
            *newnode = tmpnode;
            newnode->backnode = nownode;

            /* VԂ̃RXgvZ */
            newnode->cost = playstep_getcost(newnode);

            /* L[ɐVm[ho^ */
            que_push(newnode);
        }
//      printmap(nownode);
    }
    endnode = nownode;
}


/* -------------------------------------------------------- */
int main(void)
{
    mapinit();
    playstep_search();
    printstep();
    return 0;
}
